package fr.esial.seenshare.controlers;

import fr.esial.seenshare.models.Albums;
import fr.esial.seenshare.models.Photo;
import fr.esial.seenshare.models.Video;
import fr.esial.seenshare.utils.ProjectFiles;

import javax.swing.JFileChooser;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.net.URISyntaxException;

/**
 * Class that listen for clicks on the "Add media" button
 * Shows a file chooser to select the media to add from disk and add the file to the selected album
 */
public class AddMediaListener implements ActionListener {

    @Override
    public void actionPerformed(ActionEvent e) {
        Albums albums = Albums.getInstance();
        JFileChooser chooser = new JFileChooser();
        chooser.setDialogTitle("Select a file to add");
        chooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
        int returnVal = chooser.showOpenDialog(null);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            File f = chooser.getSelectedFile();
            try {
                if (ProjectFiles.isValidPhotoFile(f)) {
                    albums.getSelected().addMedia(
                            new Photo(f.getName(), f.getAbsolutePath()), true);
                } else if (ProjectFiles.isValidVideoFile(f)) {
                    albums.getSelected().addMedia(
                            new Video(f.getName(), f.getAbsolutePath()), true);
                }
                albums.setSelected(albums.getSelectedName());
            } catch (URISyntaxException e1) {
                e1.printStackTrace();
            }
        }
    }
}
