package fr.esial.seenshare.controlers;

import javax.swing.JTree;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.DefaultMutableTreeNode;

import fr.esial.seenshare.models.Albums;
import fr.esial.seenshare.models.CurrentProgressStatus;

/**
 * Controller listening clicks on albums
 */

public class AlbumsSelectionListener implements TreeSelectionListener {

    private Albums albums;

    /**
     * @param albums list of all albums
     */
    public AlbumsSelectionListener(Albums albums) {
        this.albums = albums;
    }

    @Override
    /**
     * Action to do when selected value changed
     */
    public void valueChanged(TreeSelectionEvent e) {
        JTree tree = (JTree) e.getSource();

        CurrentProgressStatus.getInstance().setIndeterminate();

        if (tree.getLastSelectedPathComponent() != null) {
            albums.setSelected((String) ((DefaultMutableTreeNode) tree
                    .getLastSelectedPathComponent()).getUserObject());
        }
    }
}
