package fr.esial.seenshare.controlers;

import fr.esial.seenshare.models.Albums;
import fr.esial.seenshare.views.ErrorPopup;

import java.awt.event.*;
import java.io.IOException;

/**
 * Controller that listens all actions that can close the software
 */
public class CloseSoftware implements WindowListener, KeyListener, ActionListener {

    private boolean ctrlDown = false;

    /**
     * Close the software
     * It stops all threads that can access data
     * It saves all local data in a local file
     */
    public void close() {
        Albums.stopThreads();
        try {
            Albums.getInstance().saveAlbums();
        } catch (IOException e) {
            ErrorPopup.showIOError();
        }
        System.exit(0);
    }

    @Override
    public void windowOpened(WindowEvent windowEvent) {
    }

    @Override
    public void windowClosing(WindowEvent windowEvent) {
    }

    @Override
    public void windowClosed(WindowEvent windowEvent) {
    }

    @Override
    public void windowIconified(WindowEvent windowEvent) {
    }

    @Override
    public void windowDeiconified(WindowEvent windowEvent) {
    }

    @Override
    public void windowActivated(WindowEvent windowEvent) {
    }

    @Override
    public void windowDeactivated(WindowEvent windowEvent) {
    }

    @Override
    public void keyTyped(KeyEvent keyEvent) {
        if ((keyEvent.getKeyChar() == 'q') && ctrlDown)
            close();
    }

    @Override
    public void keyPressed(KeyEvent keyEvent) {
        if (keyEvent.isControlDown())
            ctrlDown = true;
    }

    @Override
    public void keyReleased(KeyEvent keyEvent) {
        if (!keyEvent.isControlDown())
            ctrlDown = false;
    }

    @Override
    public void actionPerformed(ActionEvent actionEvent) {
        close();
    }
}
