package fr.esial.seenshare.controlers;


import com.google.gdata.util.ServiceException;
import fr.esial.seenshare.models.Albums;
import fr.esial.seenshare.models.AlbumsMessage;
import fr.esial.seenshare.models.GoogleService;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.net.URISyntaxException;

/**
 * Controller that listens clicks on the connection button
 * It transforms a connection button into disconnection button
 */
public class ConnectionListener implements ActionListener {

    private Albums albums;

    public ConnectionListener() {
        albums = Albums.getInstance();
    }

    @Override
    public void actionPerformed(ActionEvent actionEvent) {
        JButton connectButton = (JButton) actionEvent.getSource();

        // try to connect the user
        if (connectButton.getActionCommand().compareTo("connect") == 0) {
            // Load online albums
            try {
                albums.loadOnlineAlbums();
            } catch (Exception ex) {
                ex.printStackTrace();
            }

            // Sync albums
            try {
                albums.syncAlbums();
            } catch (IOException ex) {
                ex.printStackTrace();
            } catch (ServiceException ex) {
                ex.printStackTrace();
            } catch (URISyntaxException ex) {
                ex.printStackTrace();
            }

            if (!GoogleService.isNull()) {
                albums.refreshObservers(AlbumsMessage.CONNECTION);
            }

            // disconnect the user
        } else if (connectButton.getActionCommand().compareTo("disconnect") == 0) {
            GoogleService.setNull();
            albums.removeOnlineAlbums();
            albums.refreshObservers(AlbumsMessage.DISCONNECTION);
        }
    }
}
