package fr.esial.seenshare.controlers;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import fr.esial.seenshare.models.Photo;
import fr.esial.seenshare.views.ResizePopup;

/**
 * Controller that listen the buttons to edit a photo (rotate or resize)
 */
public class ImageEditButtonsActionListener implements ActionListener {

    Photo photo;
    PicturePanelMouseListener ppml;

    public ImageEditButtonsActionListener(Photo m, PicturePanelMouseListener ppml) {
        this.photo = m;
        this.ppml = ppml;
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        if (e.getActionCommand() == "rotate_left") {
            photo.rotate(Photo.COUNTER_CLOCKWISE);
        } else if (e.getActionCommand() == "rotate_right") {
            photo.rotate(Photo.CLOCKWISE);
        } else if (e.getActionCommand() == "resize") {
            new ResizePopup(photo);
        } else if (e.getActionCommand() == "crop") {
            ppml.setCropping(true);
            ppml.setPressed(false);
        } else if (e.getActionCommand() == "person") {
            ppml.setTagging(true);
        } else if (e.getActionCommand() == "sepia") {
            photo.toSepia();
        } else if (e.getActionCommand() == "bw") {
            photo.toBW();
        } else if (e.getActionCommand() == "blur") {
            photo.toBlur();
        }
    }

}
