package fr.esial.seenshare.controlers;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JComboBox;

import fr.esial.seenshare.models.Albums;
import fr.esial.seenshare.views.SearchView;

/**
 * Controller that listen for inputs in the search field, and launch the searches
 */
public class SearchActionListener implements ActionListener {
    private Albums albums;
    private JComboBox typeCombo;
    private JComboBox whereCombo;

    public SearchActionListener(Albums albums, JComboBox type, JComboBox where) {
        this.albums = albums;
        this.typeCombo = type;
        this.whereCombo = where;
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        SearchView search = (SearchView) e.getSource();
        String type = (String) typeCombo.getSelectedItem();
        String where = (String) whereCombo.getSelectedItem();

        albums.search(search.getText(), type, where);
    }
}
