package fr.esial.seenshare.controlers;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JFrame;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;

/**
 * Controller that listen for clicks on the theme switcher button
 * Update the Look&Feel of the software
 */
public class ThemeListener implements ActionListener {

    private JFrame parent;
    private String name;

    public ThemeListener(JFrame p, String n) {
        parent = p;
        name = n;
    }

    @Override
    public void actionPerformed(ActionEvent a) {
        try {
            UIManager.setLookAndFeel(name);
            SwingUtilities.updateComponentTreeUI(parent);
        } catch (UnsupportedLookAndFeelException e) {
            e.printStackTrace();
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (InstantiationException e) {
            e.printStackTrace();
        } catch (IllegalAccessException e) {
            e.printStackTrace();
        }
    }
}
