package fr.esial.seenshare.models;

import java.util.ArrayList;
import java.util.ListIterator;


/**
 * Iterator pattern through a list of medias for slideshow purpose
 */
public class DiaporamaIterator implements ListIterator<Media> {

    private ArrayList<Media> alm;
    private int index;

    public DiaporamaIterator(ArrayList<Media> alm) {
        this.alm = alm;
        index = -1;
    }

    @Override
    public void add(Media e) {
        return;
    }

    @Override
    public boolean hasNext() {
        return index < alm.size() - 1;
    }

    @Override
    public boolean hasPrevious() {
        return index > 0 || index == -1;
    }

    @Override
    public Media next() {
        if (hasNext()) {
            index++;
        }
        return alm.get(index);
    }

    @Override
    public int nextIndex() {
        if (hasNext()) {
            return index + 1;
        } else {
            return index;
        }
    }

    @Override
    public Media previous() {
        if (hasPrevious()) {
            index--;
        }
        return alm.get(index);
    }

    @Override
    public int previousIndex() {
        if (hasPrevious()) {
            return index - 1;
        } else {
            return index;
        }
    }

    @Override
    public void remove() {
        return;

    }

    @Override
    public void set(Media e) {
        return;
    }

}
