package fr.esial.seenshare.models;

import java.io.IOException;
import java.net.URISyntaxException;
import java.net.UnknownHostException;

import com.google.gdata.util.ServiceException;
import fr.esial.seenshare.views.ErrorPopup;

/**
 * Thread that launches the loading of albums from disk and from PicasaWeb
 */
public class LoadAlbumsThread extends Thread {

    @Override
    public void run() {
        super.run();
        try {
            Albums.addThread(this);
            CurrentProgressStatus.getInstance().setIndeterminate();

            Albums.getInstance().loadAlbums();
            Albums.getInstance().loadOnlineAlbums();

        } catch (UnknownHostException e) {
            ErrorPopup.showNetworkError();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (ServiceException e) {
            ErrorPopup.showServiceError();
        } catch (URISyntaxException e) {
            e.printStackTrace();
        }
    }
}
