package fr.esial.seenshare.models;

import java.io.IOException;
import java.net.URISyntaxException;
import java.net.UnknownHostException;

import com.google.gdata.util.ServiceException;
import fr.esial.seenshare.views.ErrorPopup;


/**
 * Thread that loads all online albums data (and its medias)
 */
public class LoadOnlineAlbumsDataThread extends Thread {

    private Album a;

    public LoadOnlineAlbumsDataThread(Album a) {
        this.a = a;
    }

    @Override
    public void run() {
        super.run();
        try {
            Albums.addThread(this);

            a.loadOnlineData();
        } catch (UnknownHostException e) {
            ErrorPopup.showNetworkError();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (ServiceException e) {
            ErrorPopup.showServiceError();
        } catch (URISyntaxException e) {
            e.printStackTrace();
        }
    }
}