package fr.esial.seenshare.models;

import java.awt.Point;

/**
 * Class that represents a person on a photo : a person w/ a name circled by a rectangle
 */
public class Person {

    private String name;
    private Point p1;
    private Point p2;

    /**
     * Creates a new person
     *
     * @param name name of the person
     * @param p1   first point of the rectangle
     * @param p2   second point of the rectangle
     */
    public Person(String name, Point p1, Point p2) {
        this.name = name;
        this.p1 = p1;
        this.p2 = p2;
    }

    /**
     * Get the person name
     *
     * @return name of the person
     */
    public String getName() {
        return name;
    }

    /**
     * Set the name of the person
     *
     * @param name new name for the person
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * Get the first point of the rectangle
     *
     * @return first point of the rectangle
     */
    public Point getP1() {
        return p1;
    }

    /**
     * Set the first point of the rectangle
     *
     * @param p1 first point of the rectangle
     */
    public void setP1(Point p1) {
        this.p1 = p1;
    }

    /**
     * Get the second point of the rectangle
     *
     * @return second point of the rectangle
     */
    public Point getP2() {
        return p2;
    }

    /**
     * set the second point of the rectangle
     *
     * @param p2 second point of the rectangle to set
     */
    public void setP2(Point p2) {
        this.p2 = p2;
    }
}
