package fr.esial.seenshare.models;

/**
 * Thread that saves a modified resource online
 * It can save title, description, tags, geolocation, media file, ...
 */
public class SaveResourceThread extends Thread {

    @SuppressWarnings("rawtypes")
    private Resource resource;
    private boolean updateMedia;

    /**
     * Create a new thread to save a given resource
     *
     * @param r resource to save
     */
    public SaveResourceThread(Resource r) {
        resource = r;
        this.updateMedia = false;
    }

    /**
     * Create a new thread to save a given resource
     *
     * @param r           resource to save
     * @param updateMedia update the media file
     */
    @SuppressWarnings("rawtypes")
    public SaveResourceThread(Resource r, boolean updateMedia) {
        resource = r;
        this.updateMedia = updateMedia;
    }

    @Override
    public void run() {
        super.run();
        resource.save(updateMedia);
    }

}
