package fr.esial.seenshare.models;

import java.io.IOException;
import java.net.URISyntaxException;
import java.net.UnknownHostException;
import javax.swing.JOptionPane;

import com.google.gdata.util.ServiceException;
import fr.esial.seenshare.views.ErrorPopup;

/**
 * Thread that syncs a new album
 */
public class SyncNewAlbumThread extends Thread {

    private Album album;

    public SyncNewAlbumThread(Album a) {
        this.album = a;
    }

    @SuppressWarnings("deprecation")
    @Override
    public void run() {
        super.run();
        try {
            Albums.addThread(this);
            album.synchronizeNewAlbum();

        } catch (UnknownHostException e) {
            ErrorPopup.showNetworkError();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (ServiceException e) {
            ErrorPopup.showServiceError();
        } catch (URISyntaxException e) {
            e.printStackTrace();
        }
    }
}
