package fr.esial.seenshare.models.tests;

import java.io.IOException;
import java.net.URISyntaxException;

import com.google.gdata.util.ServiceException;

import fr.esial.seenshare.models.Album;
import fr.esial.seenshare.models.Albums;
import fr.esial.seenshare.utils.Constants;
import junit.framework.TestCase;

public class AlbumsTest extends TestCase {
	Album album1, album2, album3; 
	Albums albums;

	public void setUp() {
		try {
			Constants.setJUNIT(true);
			albums = Albums.getNewInstance();
			
			album1 = new Album("testAlbum1");
			album2 = new Album("testAlbum2");
			album3 = new Album("testAlbum3");

		} catch (URISyntaxException e) {
			e.printStackTrace();
		}
	}

	public void testAddAlbum() {
		System.out.println("testAddAlbum : ajout album1");
		albums.addAlbum(album1);
		assertEquals(albums.getAlbums().size(), 1);

		System.out.println("testAddAlbum : ajout album2");
		albums.addAlbum(album2);
		assertEquals(albums.getAlbums().size(), 2);

		System.out.println("testAddAlbum : ajout album3");
		albums.addAlbum(album3);
		assertEquals(albums.getAlbums().size(), 3);
	}

	public void testRemoveAlbum() {
		/*System.out.println("testRemoveAlbum : ajout et suppression 1 album");
		albums.addAlbum(album1);
		albums.removeAlbum(album1.getTitle(), false);
		assertEquals(albums.getAlbums().size(), 0);
		
		System.out.println("testRemoveAlbum : ajout 2 albums et suppression 1 album");
		albums.addAlbum(album1);
		albums.addAlbum(album2);
		albums.removeAlbum(album1.getTitle(), false);
		assertEquals(albums.getAlbums().size(), 1);
		
		System.out.println("testRemoveAlbum : ajout 3 albums et suppression 1 album");
		albums.addAlbum(album1);
		albums.addAlbum(album3);
		albums.removeAlbum(album1.getTitle(), false);
		assertEquals(albums.getAlbums().size(), 2);*/
	}

	public void testSize() {
		System.out.println("testSize : ajout album1");
		albums.addAlbum(album1);
		assertEquals(albums.size(), 1);
		
		System.out.println("testSize : ajout album2");
		albums.addAlbum(album2);
		assertEquals(albums.size(), 2);
		
		System.out.println("testSize : ajout album3");
		albums.addAlbum(album3);
		assertEquals(albums.size(), 3);
	}

	public void testGetTree() {
		System.out.println("testGetTree : verifie la taille de l'arbre");
		albums.addAlbum(album1);
		albums.addAlbum(album2);
		albums.addAlbum(album3);
		assertEquals(3, albums.getTree().getChildCount());
	}

	public void testLoadAlbums() {
		Albums albums2;
		String data = Constants.DATA; 
		Constants.DATA = "data/tests/albums.data";
		
		try {
			System.out.println("testLoadAlbums : charge le fichier de test data/tests/albums.data");
			
			albums.addAlbum(album1);
			albums.addAlbum(album2);
			albums.addAlbum(album3);
			
			albums2 = Albums.getNewInstance();
			albums2.loadAlbums();
			
			assertEquals(albums2.size(), 3);
			assertEquals(albums.getAlbums().get("testAlbum2").getTitle(), album2.getTitle());
			
		} catch (IOException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
		
		Constants.DATA = data;	
	}

	public void testSaveAlbums() {
		Albums albums2;
		
		System.out.println("testSaveAlbums : verifie l'enregistrement des albums");
		
		try {
			albums.addAlbum(album1);
			albums.addAlbum(album2);
			albums.addAlbum(album3);
			albums.saveAlbums();
			
			albums2 = Albums.getNewInstance();
			albums2.loadAlbums();
			
			assertEquals(albums2.size(), 3);

			for(String toto : albums.getAlbums().keySet())
				System.out.println("titre: " + toto + " :: " + albums.getAlbums().get(toto));

			//assertEquals(albums.getAlbums().get("testAlbum2"), album2);
			
		} catch (IOException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
	}

	public void testAddFolder() {
		System.out.println("testAddFolder : ajout du repertoire de tests data/tests/testPhotos");

		albums.addFolder("data/tests/testPhotos");

		assertEquals(1, albums.size());
		assertTrue(albums.getAlbums().keySet().contains("testPhotos"));
		assertEquals(3, albums.getAlbums().get("testPhotos").size());
	}
	
	public void testLoadOnlineAlbums() {
		Albums albums2 = Albums.getNewInstance();
		
		System.out.println("testLoadOnlineAlbums : test en ligne de data/tests/testPhotos");
		
		/*try {
			albums.addFolder("data/tests/testPhotos");
			albums.getAlbums().get("testPhotos").synchronizeNewAlbum();

			albums2.loadOnlineAlbums();

			assertTrue(albums.getAlbums().keySet().contains("testPhotos"));
			assertEquals(3, albums.getAlbums().get("testPhotos").size());
			
			// TODO: Supprimer l'album de tests en ligne (pas encore de fonction)

		} catch (IOException e) {
			e.printStackTrace();
		} catch (ServiceException e) {
			e.printStackTrace();
		} catch (URISyntaxException e) {
			e.printStackTrace();
		}*/
	}
}
