package fr.esial.seenshare.views;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;

import fr.esial.seenshare.models.GoogleService;
import fr.esial.seenshare.utils.Constants;
import fr.esial.seenshare.utils.FormUtility;

/**
 * View to display a dialog asking its account properties to the user
 * for test purposes, we set a default picasa test account
 */
public class ConnectionDialog extends JDialog {

    private static final long serialVersionUID = 1L;

    private JTextField tfUsername;
    private JPasswordField tfPassword;
    private JButton btnOK;

    public ConnectionDialog() {
        setTitle(Constants.TITLE_CONNECTION);
        setDefaultCloseOperation(HIDE_ON_CLOSE);
        setPreferredSize(new Dimension(300, 140));
        ImageIcon icon = new ImageIcon(getClass().getClassLoader().getResource(
                Constants.IMAGE_ICON));
        setIconImage(icon.getImage());
        setModal(true);

        tfUsername = new JTextField("projet.picasa@gmail.com");
        tfUsername.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
                btnOK.doClick();
			}
		});

        tfPassword = new JPasswordField("picasa.projet");
        tfPassword.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
                btnOK.doClick();
			}
		});
        
        btnOK = new JButton("OK");

        btnOK.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                GoogleService.setUsername(tfUsername.getText());
                GoogleService.setPassword(new String(tfPassword.getPassword()));
                setVisible(false);
            }
        });

        JPanel pForm = new JPanel(new GridBagLayout());
        pForm.setBorder(new EmptyBorder(2, 2, 2, 2));
        FormUtility formUtility = new FormUtility();
        formUtility.addLabel("Username: ", pForm);
        formUtility.addLastField(tfUsername, pForm);
        formUtility.addLabel("Password: ", pForm);
        formUtility.addLastField(tfPassword, pForm);

        JPanel pBtn = new JPanel();
        pBtn.add(btnOK);

        Container c = getContentPane();
        c.setLayout(new BorderLayout());

        c.add(pForm, BorderLayout.CENTER);
        c.add(pBtn, BorderLayout.SOUTH);

        pack();
        setLocationRelativeTo(getParent());

        setVisible(true);
    }
}
