package fr.esial.seenshare.views;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

import javax.swing.ImageIcon;
import javax.swing.JDialog;
import javax.swing.JLabel;

import fr.esial.seenshare.utils.Constants;

/**
 * Classe FrameHelp, fenêtre qui affiche le fichier d'aide
 */
public class DialogAbout extends JDialog {

	private static final long serialVersionUID = 1L;

	private String easteregg = "esial";
	private int i = 0;

	private JLabel lblIcon;

	/**
	 * Constructeur qui intialise la fenêtre d'aide
	 */
	public DialogAbout() {
		super();
		setTitle(Constants.TITLE_ABOUT);
		setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		setPreferredSize(new Dimension(450, 450));
		setModal(true);
		ImageIcon icon = new ImageIcon(getClass().getClassLoader().getResource(
				Constants.IMAGE_ICON));
		setIconImage(icon.getImage());
		setLayout(new GridBagLayout());

		lblIcon = new JLabel(icon);

		JLabel lblTitle = new JLabel(Constants.TITLE, JLabel.CENTER);
		lblTitle.setFont(new Font("SansSerif", Font.BOLD, 26));

		JLabel lblAuthors = new JLabel(
				"<html><br/>Developped with Java by:"
						+ "<ul><li>Guillaume GERARD &lt;guillaume@gerard.cx&gt;</li>"
						+ "<li>Julien GUEPIN &lt;julien@guepin.fr&gt;</li>"
						+ "<li>Adrien SIEBERT &lt;adrien.siebert@gmail.com&gt;</li>"
						+ "<li>Julien VAUBOURG &lt;julien@vaubourg.com&gt;</li></ul></html>");
		lblAuthors.setFont(new Font("SansSerif", Font.BOLD, 14));

		JLabel lblInfos = new JLabel(
				"<html><br/>Special thanks to:"
						+ "<ul><li>Hernán VANZETTO &lt;hernan.vanzetto@inria.fr&gt;</li>"
						+ "<li>Google APIs</li>"
						+ "<li>IconFinder Community</li>"
						+ "<li>OpenStreetMap Community</li></ul></html>");
		lblInfos.setFont(new Font("SansSerif", Font.BOLD, 14));

		GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.HORIZONTAL;

		c.gridx = 0;
		c.gridy = 0;
		add(lblIcon, c);

		c.gridx++;
		add(lblTitle, c);

		c.gridwidth = 2;

		c.gridx--;
		c.gridy++;
		add(lblAuthors, c);

		c.gridy++;
		add(lblInfos, c);

		pack();
		setLocationRelativeTo(getParent());
		addKeyListener(new KeyAdapter() {

			public void keyPressed(KeyEvent e) {
				if (i < easteregg.length()) {
					if (easteregg.charAt(i) == e.getKeyChar()) {
						i++;
					} else {
						i = 0;
					}
					if (i == easteregg.length()) {
						ImageIcon icon = new ImageIcon(getClass()
								.getClassLoader().getResource(
										Constants.IMAGE_EGG));
						lblIcon.setIcon(icon);
					}
				}
			}
		});
		setFocusable(true);

		setVisible(true);
	}
}
