package fr.esial.seenshare.views;

import java.util.Observable;
import java.util.Observer;

import javax.swing.JComboBox;

import fr.esial.seenshare.models.Albums;
import fr.esial.seenshare.models.AlbumsMessage;

/**
 * View that displays the list of all albums in a combobox for search criterias
 */
public class SearchAlbumsView extends JComboBox implements Observer {
    private static final long serialVersionUID = 1L;

    private Albums albums;

    /**
     * Create a new view displaying the list of albums
     *
     * @param albums list of all albums
     */
    public SearchAlbumsView(Albums albums) {
        super();
        this.albums = albums;

        Albums.getInstance().addObserver(this);
        setToolTipText("In?");
    }

    @Override
    public void update(Observable o, Object arg) {
        if (o != null && o instanceof Albums) {
            if (arg != null && arg instanceof AlbumsMessage) {
                if ((AlbumsMessage) arg == AlbumsMessage.ALBUMS) {
                    removeAllItems();
                    addItem("All albums");

                    for (String st : albums.getAlbums().keySet())
                        addItem(st);
                }
            }
        }
    }
}
