package fr.esial.seenshare.views;

import java.awt.Dimension;

import javax.swing.JComboBox;
import javax.swing.JTextField;

import fr.esial.seenshare.controlers.SearchActionListener;
import fr.esial.seenshare.models.Albums;

/**
 * This view is a text field that allows to enter search queries
 */
public class SearchView extends JTextField {
    private static final long serialVersionUID = 1L;

    /**
     * Create a new search field
     *
     * @param albums list of all albums
     * @param type   combobox containing the list of all albums
     * @param where  combobox containing the types of searches
     */
    public SearchView(Albums albums, JComboBox type, JComboBox where) {
        super();
        this.addActionListener(new SearchActionListener(albums, type, where));
        this.setPreferredSize(new Dimension(200, 30));
    }
}
