package fr.esial.seenshare.views;

import java.awt.BorderLayout;
import java.awt.Desktop;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;

import fr.esial.seenshare.controlers.CloseTabListener;
import fr.esial.seenshare.models.Media;
import fr.esial.seenshare.models.ResourceStatus;
import fr.esial.seenshare.utils.Constants;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;

public class VideoPanel extends MediaPanel {

	private static final long serialVersionUID = 1L;

	public VideoPanel(final Media media, JFrame win) {
		super(media, win);

		ClassLoader cl = getClass().getClassLoader();
		ImageIcon iconPlay = new ImageIcon(cl.getResource(Constants.ICON_PLAY));
		ImageIcon iconClose = new ImageIcon(cl
				.getResource(Constants.ICON_CLOSE));

		JButton btnPlay = new JButton(iconPlay);
		btnPlay.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				if (media.getStatus() == ResourceStatus.LOCAL
						|| media.getStatus() == ResourceStatus.SYNCHRONIZED) {
					try {
						Desktop.getDesktop().open(
								new File(media.getResourcePath().getPath()));
					} catch (IOException ex) {
						ex.printStackTrace();
					}
				} else if (media.getStatus() == ResourceStatus.ONLINE) {
					try {
						Desktop.getDesktop().browse(
								new URI(media.getEntry().getMediaContents()
										.get(1).getUrl()));
					} catch (URISyntaxException ex) {
						ex.printStackTrace();
					} catch (IOException ex) {
						ex.printStackTrace();
					}
				}
			}
		});

		JButton btnClose = new JButton(iconClose);
		btnClose.addActionListener(new CloseTabListener(win, media));

		JPanel pnlLeft = new JPanel();
		JPanel pnlRight = new JPanel();
		pnlRight.setLayout(new FlowLayout(FlowLayout.RIGHT));

		pnlRight.add(btnClose);

		buttonTopPanel.add(pnlLeft, BorderLayout.WEST);
		buttonTopPanel.add(pnlRight, BorderLayout.EAST);

		add(btnPlay, BorderLayout.CENTER);

		bottomInfos.setText("");
		detailsPanel.displayDetails();
	}
}